package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.sensors.Accelerometer;
	
	import org.flixel.*;

	public class TitleState extends FlxState
	{
		
		[Embed(source = "data/img0.png")] public var img0:Class;
		[Embed(source = "data/img1.png")] public var img1:Class;
		[Embed(source = "data/img2.png")] public var img2:Class;
		[Embed(source = "data/img3.png")] public var img3:Class;
		[Embed(source = "data/img4.png")] public var img4:Class;
		[Embed(source = "data/img5.png")] public var img5:Class;
		[Embed(source = "data/img6.png")] public var img6:Class;
		
		[Embed(source = "data/img0hl.png")] public var imghl0:Class;
		[Embed(source = "data/img1hl.png")] public var imghl1:Class;
		[Embed(source = "data/img2hl.png")] public var imghl2:Class;
		[Embed(source = "data/img3hl.png")] public var imghl3:Class;
		[Embed(source = "data/img4hl.png")] public var imghl4:Class;
		[Embed(source = "data/img5hl.png")] public var imghl5:Class;
		[Embed(source = "data/imghl6.png")] public var imghl6:Class;
		
		
		[Embed(source = "data/salad_init.png")] public var imgsaladinit:Class;
		[Embed(source = "data/vomit.png")] public var imgvomit:Class;
		[Embed(source = "data/poops.png")] public var imgpoops:Class;
		private var btnarray:FlxGroup;
		
		private var btnxoffsets:Array = [0,16,35,46,62,77,94];
		private var btny:int=66;
		
		private var canvas:FlxSprite;
		private var canvas2:FlxSprite;
		
		private var brush:int=-1;
		
		private function _PressButton(i:int):void
		{
			btnarray.members[i].on=true;//!btnarray.members[i].on;
			var ison:Boolean=btnarray.members[i].on;
			for (var j:int=0;j<7;j++)
			{
				if (i==j)
				{
					continue;
				}
				else
				{
					btnarray.members[j].on=false;
				}
			}
			brush=i;
		}
			
		private function PressButton(i:int):Function
		{
			var a:Function = function():void{
				_PressButton(i);
			}	
			return a;
		}
		
		override public function create():void
		{
			super.create();
			
			
			var s:Bitmap = new imgsaladinit();
			saladleaves =  s.bitmapData;
			
			s = new imgvomit();
			vomitbmd = s.bitmapData;
			
			s = new imgpoops();
			poopbmd = s.bitmapData;
			
			bgColor=0xffffff;	
			btnarray = new FlxGroup();
			add(btnarray);
			
			for (var i:int=0;i<btnxoffsets.length;i++)
			{
				var btn:FlxButton = new FlxButton(btnxoffsets[i],btny,PressButton(i));
				var img:FlxSprite = new FlxSprite(0,0,this["img"+i]);
				var imghighlight:FlxSprite = new FlxSprite(0,0,this["imghl"+i]);
				btn.loadGraphic(img,imghighlight);
				//btn.on=true;
				btnarray.add(btn);
			}
			
			canvas = new FlxSprite(0,0);
			canvas.createGraphic(115,66);
			add(canvas);
			
			canvas2 = new FlxSprite(0,0);
			canvas2.createGraphic(115,66,0x00ffffff);
			add(canvas2);
			
			
		}
		
		private function BeerPaint(x:int,y:int):void
		{
			var col:uint=0xffffff;
			var bmd:BitmapData = canvas._framePixels;
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}	
		}
		private function SunPaint(x:int,y:int):void
		{
			var col:uint=0xeae7ff;
			var bmd:BitmapData = canvas._framePixels;
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}	
		}
		private function LotionPaint(x:int,y:int):void
		{
			var col:uint=0xcccffa;
			var bmd:BitmapData = canvas._framePixels;
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}
		}
		private function SandPaint(x:int,y:int):void
		{
			var col:uint=0xabc0e3;
			var bmd:BitmapData = canvas._framePixels;
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}
		}
		private function LovePaint(x:int,y:int):void
		{
			var col:uint=0x85a5a2;
			var bmd:BitmapData = canvas._framePixels;
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}
		}
		private function SmokePaint(x:int,y:int):void
		{
			var col:uint=0x4b743a;
			var bmd:BitmapData = canvas._framePixels;	
			for (var i:int=x-r;i<=x+r;i++)
			{
				for (var j:int=y-r;j<=y+r;j++)
				{
					bmd.setPixel(i,j,col);
				}
			}

		}
		private var r:int=3;
		
		private var lastplacement:Number=0;
		private var placementinterval:Number=0.05;

		private var poopon:Boolean=false;
		private var pooptimer:Number=-1;
		
		private var vomittimer:Number=1;
		
		private function SaladPaint(x:int,y:int):void
		{
			if (poopon==false&&pooptimer<0)
			{
				pooptimer = 5;
			}
			
			lastplacement-=FlxG.elapsed;
			if (lastplacement<0)
			{
				RandSplat(saladleaves,x,y,false);
				lastplacement=placementinterval;
			}
		}
		
		private function RandSplat(sourcebmd:BitmapData,x:int,y:int,fg:Boolean=true):void
		{
			var bmd:BitmapData =fg?canvas2._framePixels: canvas._framePixels;
			var rand:int = (int)(Math.random()*bmd.width/12);
			var rect:Rectangle = new Rectangle(rand*12,0,12,12);
			bmd.copyPixels(sourcebmd,rect,new Point(x-6,y-6),null,null,true);		
		}
		
		private var saladleaves:BitmapData;
		private var vomitbmd:BitmapData;
		private var poopbmd:BitmapData;
		
		private function poop(x:int,y:int):void
		{
			var rad:int=1;
			RandSplat(poopbmd,x+Math.random()*2*rad-rad,y+Math.random()*2*rad-rad);
		}
		private function vomit(x:int,y:int):void
		{
			var rad:int=5;
			RandSplat(vomitbmd,x+Math.random()*2*rad-rad,y+Math.random()*2*rad-rad);
		}
		override public function update():void
		{			
			super.update();
			
			if (brush>=0 && FlxG.mouse.y<66 && FlxG.mouse.pressed() && x>=0 && x<115)
			{
				switch(brush)
				{
					case 0:
						BeerPaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 1:
						SunPaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 2:
						LotionPaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 3:
						SandPaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 4:
						LovePaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 5:
						SmokePaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
					case 6:
						SaladPaint(FlxG.mouse.x,FlxG.mouse.y);
						break;
				}
			}
			else			
			{
				lastplacement=0;				
			}
			
			
			if (poopon)
			{
				if (pooptimer>0)
				{
					pooptimer-=FlxG.elapsed;			
					if (pooptimer<=0)
					{
						poop(FlxG.mouse.x,FlxG.mouse.y);
						pooptimer = -(Math.random()*1+0.5);
					}					
					else
					{
					}
				}
				else
				{
					pooptimer+=FlxG.elapsed;
					poop(FlxG.mouse.x,FlxG.mouse.y);
					if (pooptimer>=0)
					{
						pooptimer = 1+Math.random()*3;//
					}
					else
					{						
						poop(FlxG.mouse.x,FlxG.mouse.y);
					}									
				}
				
				
				
				
				
				
				
				if (vomittimer>0)
				{
					vomittimer-=FlxG.elapsed;			
					if (vomittimer<=0)
					{
						vomit(FlxG.mouse.x,FlxG.mouse.y);
						vomittimer = -(Math.random()*1)*(Math.random()*1);
					}					
					else
					{
					}
				}
				else
				{
					vomittimer+=FlxG.elapsed;
					vomit(FlxG.mouse.x,FlxG.mouse.y);
					if (vomittimer>=0)
					{
						vomittimer = 4+Math.random()*5;//
					}
					else
					{						
						vomit(FlxG.mouse.x,FlxG.mouse.y);
					}									
				}
			}
			else
			{				
				if (pooptimer>0)
				{
					pooptimer-=FlxG.elapsed;
					if (pooptimer<=0)
					{
						poopon=true;						
					}
				}
			}					
		}
	}
}